package com.namasoft.contracts.common.dtos;

import com.namasoft.common.flatobjects.EntityReferenceData;
import com.namasoft.modules.commonbasic.contracts.details.DTOMasterGroupEncodingLine;
import com.namasoft.modules.commonbasic.contracts.valueobjects.DTOItemCodingFormula;

import jakarta.xml.bind.annotation.*;
import java.util.List;

@SuppressWarnings("serial")
@XmlRootElement
@XmlAccessorType(XmlAccessType.PROPERTY)
public class DTOMasterGroup extends MasterFileDTO
{
	private String forType;
	private Boolean isLeaf;
	private EntityReferenceData parent;
	private DTOAutoCodingParams autoCodingParams;
	private String altCode;
	private DTOItemCodingFormula codingFormula;
	private EntityReferenceData filters;
	private EntityReferenceData template;
	private List<DTOMasterGroupEncodingLine> details;
	private Boolean reviseWithCommit;
	private String autoSaveAfterInputInFields;
	private String autoSaveBehavior;
	private String addLineToGridAfterAutoSave;
	private String focusFieldAfterAutoSave;
	private String taxAuthorityCode;

	public Boolean getReviseWithCommit()
	{
		return reviseWithCommit;
	}

	public void setReviseWithCommit(Boolean reviseWithCommit)
	{
		this.reviseWithCommit = reviseWithCommit;
	}

	public String getForType()
	{
		return forType;
	}

	public void setForType(String forType)
	{
		this.forType = forType;
	}

	public Boolean getIsLeaf()
	{
		return isLeaf;
	}

	public void setIsLeaf(Boolean isLeaf)
	{
		this.isLeaf = isLeaf;
	}

	public EntityReferenceData getParent()
	{
		return parent;
	}

	public void setParent(EntityReferenceData parent)
	{
		this.parent = parent;
	}

	public DTOAutoCodingParams getAutoCodingParams()
	{
		return autoCodingParams;
	}

	public void setAutoCodingParams(DTOAutoCodingParams autoCodingParams)
	{
		this.autoCodingParams = autoCodingParams;
	}

	public String getAltCode()
	{
		return altCode;
	}

	public void setAltCode(String altCode)
	{
		this.altCode = altCode;
	}

	public DTOItemCodingFormula getCodingFormula()
	{
		return codingFormula;
	}

	public void setCodingFormula(DTOItemCodingFormula itemCodingFormula)
	{
		this.codingFormula = itemCodingFormula;
	}

	public EntityReferenceData getFilters()
	{
		return filters;
	}

	public void setFilters(EntityReferenceData filters)
	{
		this.filters = filters;
	}

	public EntityReferenceData getTemplate()
	{
		return template;
	}

	public void setTemplate(EntityReferenceData template)
	{
		this.template = template;
	}

	public List<DTOMasterGroupEncodingLine> getDetails()
	{
		return details;
	}

	public void setDetails(List<DTOMasterGroupEncodingLine> details)
	{
		this.details = details;
	}

	public String getAutoSaveAfterInputInFields()
	{
		return autoSaveAfterInputInFields;
	}

	public void setAutoSaveAfterInputInFields(String autoSaveAfterInputInFields)
	{
		this.autoSaveAfterInputInFields = autoSaveAfterInputInFields;
	}

	public String getAutoSaveBehavior()
	{
		return autoSaveBehavior;
	}

	public void setAutoSaveBehavior(String autoSaveBehavior)
	{
		this.autoSaveBehavior = autoSaveBehavior;
	}

	public String getAddLineToGridAfterAutoSave()
	{
		return addLineToGridAfterAutoSave;
	}

	public void setAddLineToGridAfterAutoSave(String addLineToGridAfterAutoSave)
	{
		this.addLineToGridAfterAutoSave = addLineToGridAfterAutoSave;
	}

	public String getFocusFieldAfterAutoSave()
	{
		return focusFieldAfterAutoSave;
	}

	public void setFocusFieldAfterAutoSave(String focusFieldAfterAutoSave)
	{
		this.focusFieldAfterAutoSave = focusFieldAfterAutoSave;
	}

	public String getTaxAuthorityCode()
	{
		return taxAuthorityCode;
	}

	public void setTaxAuthorityCode(String taxAuthorityCode)
	{
		this.taxAuthorityCode = taxAuthorityCode;
	}

	@Override
	public String fetchDocTypeOrForTypeForBook_Term_Group()
	{
		return forType;
	}
}
