package com.namasoft.contracts.common.dtos.requests;

import com.namasoft.common.criteria.*;
import com.namasoft.common.layout.Owner;
import jakarta.xml.bind.annotation.*;

import java.util.*;

@SuppressWarnings("serial")
@XmlAccessorType(XmlAccessType.PROPERTY)
public class AGGridListRequest extends ServiceRequest
{
	private String entityType;
	private Owner owner;
	private String listId;
	private List<String> displayedColumns;
	private AGGridGetRowsRequest agGridRequest;
	private String orderBy;
	private DTOCriteria criteria;
	private List<DTOFilledQuestionField> questionFields;
	private DTOCriteria extraCriteria;
	private String extraCriteriaId;
	private String menuItemExtraCriteriaId;
	private Boolean ascending = true;
	private Boolean forSearch;
	private String valueToSearch;
	private String treeSelectedNodeId;
	private List<String> columnsToSearchIn;
	private Map<String, String> filterModelFieldsType;

	public AGGridListRequest()
	{
	}

	public String getEntityType()
	{
		return entityType;
	}

	public void setEntityType(String entityType)
	{
		this.entityType = entityType;
	}

	public Owner getOwner()
	{
		return owner;
	}

	public void setOwner(Owner owner)
	{
		this.owner = owner;
	}

	public String getListId()
	{
		return listId;
	}

	public void setListId(String listId)
	{
		this.listId = listId;
	}

	public List<String> getDisplayedColumns()
	{
		return displayedColumns;
	}

	public void setDisplayedColumns(List<String> displayedColumns)
	{
		this.displayedColumns = displayedColumns;
	}

	public AGGridGetRowsRequest getAgGridRequest()
	{
		return agGridRequest;
	}

	public void setAgGridRequest(AGGridGetRowsRequest agGridRequest)
	{
		this.agGridRequest = agGridRequest;
	}

	public String getOrderBy()
	{
		return orderBy;
	}

	public void setOrderBy(String orderBy)
	{
		this.orderBy = orderBy;
	}

	public DTOCriteria getCriteria()
	{
		return criteria;
	}

	public void setCriteria(DTOCriteria criteria)
	{
		this.criteria = criteria;
	}

	public List<DTOFilledQuestionField> getQuestionFields()
	{
		return questionFields;
	}

	public void setQuestionFields(List<DTOFilledQuestionField> questionFields)
	{
		this.questionFields = questionFields;
	}

	public DTOCriteria getExtraCriteria()
	{
		return extraCriteria;
	}

	public void setExtraCriteria(DTOCriteria extraCriteria)
	{
		this.extraCriteria = extraCriteria;
	}

	public String getExtraCriteriaId()
	{
		return extraCriteriaId;
	}

	public void setExtraCriteriaId(String extraCriteriaId)
	{
		this.extraCriteriaId = extraCriteriaId;
	}

	public String getMenuItemExtraCriteriaId()
	{
		return menuItemExtraCriteriaId;
	}

	public void setMenuItemExtraCriteriaId(String menuItemExtraCriteriaId)
	{
		this.menuItemExtraCriteriaId = menuItemExtraCriteriaId;
	}

	public Boolean getAscending()
	{
		return ascending;
	}

	public void setAscending(Boolean ascending)
	{
		this.ascending = ascending;
	}

	public Boolean getForSearch()
	{
		return forSearch;
	}

	public void setForSearch(Boolean forSearch)
	{
		this.forSearch = forSearch;
	}

	public String getValueToSearch()
	{
		return valueToSearch;
	}

	public void setValueToSearch(String valueToSearch)
	{
		this.valueToSearch = valueToSearch;
	}

	public List<String> getColumnsToSearchIn()
	{
		return columnsToSearchIn;
	}

	public void setColumnsToSearchIn(List<String> columnsToSearchIn)
	{
		this.columnsToSearchIn = columnsToSearchIn;
	}

	public String getTreeSelectedNodeId()
	{
		return treeSelectedNodeId;
	}

	public void setTreeSelectedNodeId(String treeSelectedNodeId)
	{
		this.treeSelectedNodeId = treeSelectedNodeId;
	}

	public Map<String, String> getFilterModelFieldsType()
	{
		return filterModelFieldsType;
	}

	public void setFilterModelFieldsType(Map<String, String> filterModelFieldsType)
	{
		this.filterModelFieldsType = filterModelFieldsType;
	}
}
