package com.namasoft.contracts.common.dtos.results;

import java.io.Serializable;

import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlRootElement;

import com.namasoft.common.ResultDTO;
import com.namasoft.common.ServiceResponse;

@XmlRootElement
@XmlAccessorType(XmlAccessType.PROPERTY)
public class GetResult<DTO> extends ServiceResponse implements Serializable
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -6005122555414142370L;
	private DTO data;

	public GetResult()
	{
	}

	public GetResult(DTO data)
	{
		this(data, ResultDTO.success());
	}

	public GetResult(DTO data, ResultDTO result)
	{
		super(result);
		setData(data);
	}

	public DTO getData()
	{
		return data;
	}

	public void setData(DTO data)
	{
		this.data = data;
	}

}